% ISSUE WITH GOVERNEMENT SPENDING HERE! AS SOON AS NOT ZERO IN STEADY STATE NOT STABLE ANYMORE
% MAYBE SIZE OF G HAS TO ADJUSTED FOR SIZE OF THE COUNTRY AGAIN??? CHECK THIS SOON! 


% TWO COUNTRIES IN A MONETARY UNION
% TRADE IN TRADEABLE GOODS
% TWO SECTORS IN EACH ECONOMY (T AND N)
% STICKY PRICES AND FLEXIBLE WAGES
% INCOMPLETE FINANCIAL MARKETS (INTERNATIONAL BOND)
% MONETARY POLICY SHOCK, FOUR SHOCKS TO TECHNOLOGY IN H and F AND GOVERNMENT SPENDING SHOCKS
% ADDED FEATURES TO COMPLY WITH RABANAL FRAMEWORK: 
% - PERSISTENCE IN INTEREST RATE 
% - INDEXATION
% - HABIT FORMATION
% - COUNTRIES OF DIFFERENT SIZE
% THE MODEL NESTS COMMON AND SECTOR-SPECIFIC WAGE SET-UP VIA alpha

close all; clc; 

var 
%%%%%%%% HOME/FOREIGN ECONOMY %%%%%%%%%%
    C C_star                                % AGGREGATE CONSUMPTION   
    U_C U_Cstar                             % MARGINAL UTILITY OF CONSUMPTION        
    C_T C_Tstar                             % CONSUMPTION OF TRADED GOODS
    C_N C_Nstar                             % CONSUMPTION OF NON-TRADED GOODS
    Y Y_star                                % AGREGGATE OUTPUT (10)
    Y_T Y_Tstar                             % TRADED OUTPUT
    Y_N Y_Nstar                             % NON-TRADED OUTPUT
    G_N G_Nstar                             % GOVERNMENT CONSUMPTION OF N GOODS
    G_T G_Tstar                             % GOVERNMENT CONSUMPTION OF T GOODS
    L L_star                                % AGGREGATE LABOUR (20)
    L_T L_Tstar                             % LABOUR IN TRADED SECTOR
    L_N L_Nstar                             % LABOUR IN NON-TRADED SECTOR
    V V_star                                % AUXILIARY VARIABLE
    w_T w_Tstar                             % REAL WAGE IN TRADED SECTOR
    w_N w_Nstar                             % REAL WAGE IN NON-TRADED SECTOR (30)
    mc_T mc_Tstar                           % REAL MARGINAL COSTS IN TRADED SECTOR
    mc_N mc_Nstar                           % REAL MARGINAL COSTS IN NON-TRADED SECTOR
    Pie Pie_star                            % GROSS CPI INFLATION
    Pie_T Pie_Tstar                         % TRADED GOODS INFLATION
    Pie_N Pie_Nstar                         % NON-TRADED GOODS INFLATION (40)
    Pie_H Pie_F                             % INFLATION OF DOMESTICALLY PRODUCED TRADED GOODS
    Pie_TW Pie_TWstar                       % WAGE INFLATION IN TRADED SECTOR
    Pie_NW Pie_NWstar                       % WAGE INFLATION IN NON-TRADED SECTOR
    pop_H pop_F pop_N pop_Nstar             % OPTIMAL RELATIVE TO ACTUAL PRICE (50)
    dp_H dp_F dp_N dp_Nstar                 % PRICE DISPERSION TERMS
    p_T_over_p_H                            % P_T/P_H
    p_over_p_T                              % P/P_T
    p_over_p_N                              % P/P_N
    p_Tstar_over_p_F                        % P_star/P_F
    p_star_over_p_Tstar                     % P_star/P_Tstar
    p_star_over_p_Nstar                     % P_star/P_Nstar (60)
    x1_T x1_Tstar x2_T x2_Tstar             % AUXILIARY SG&U (2003)    
    x1_N x1_Nstar x2_N x2_Nstar             % AUXILIARY SG&U (2003)     
    Z_T Z_Tstar Z_N Z_Nstar                 % TECHNOLGY
    X                                       % AREA WIDE TECHNOLOGY  
    b b_star                                % REAL DEBT 
    Q_H Q_F                                 % STOCHASTIC DISCOUNT FACTOR
%%%%%%%% 'GLOBAL' VARIABLES %%%%%%%%%%
    Pie_U                                   % UNION-WIDE INFLATION
    ToT                                     % EXTERNAL TERMS OF TRADE
    ToT_N ToT_Nstar                         % INTERNAL TERMS OF TRADE
    R                                       % NOMINAL INTEREST RATE
    LUMP LUMP_star                          % LUMP-SUM TAXES    
    NONTRADEDINFLATION                      % (85)
    REL 
%%%%%%%% OBSERVED VARIABLES %%%%%%%%%%
Pie_obs
Pie_N_obs
Pie_star_obs
Pie_Nstar_obs
L_T_obs
L_obs
Y_obs
Y_N_obs
Y_star_obs
Y_Nstar_obs
R_obs
     ; 
varexo  e_Z_T e_Z_N e_Z_Tstar e_Z_Nstar e_M e_GN e_GNstar e_GT e_GTstar e_X e_T 
        ME_L_T ME_L ME_Y ME_Y_N ME_Ystar ME_Y_Nstar;  

%%%%%%%% PARAMETERS %%%%%%%%%%
 parameters n beta sigma kappa epsilon varphi iota RP habit
            thetaH thetaN thetaF thetaNstar
            mu_H mu_F mu_N mu_Nstar
            omegaH omegaF delta deltastar
            phi rho_R rho_ZN rho_ZT rho_ZTstar rho_ZNstar rho_X rho_G_N rho_G_T 
            GY_T GY_N GY_Tstar GY_Nstar 
            alpha alpha_star gamma gamma_star;

% CALIBRATED ACCORDING TO RABANAL (2009)
 n = 0.89;              % SIZE OF THE FOREIGN ECONOMY
 beta = 0.99;           % DISCOUNT FACTOR
 sigma = 1;             % COEFFICIENT OF RELATIVE RISK AVERSION
 kappa = 1;             % INVERSE OF FRISCH ELASTICITY OF LABOUR SUPPLY
 habit = 0.6;             % HABIT PARAMETER
 RP = 0.001;            % RISK PREMIUM

 % omegaH = OMEGA*n;      % STEADY STATE IMPORT SHARE IN H EQUAL TO RELATIVE SIZE OF THE OTHER COUNTRY
 % omegaF = OMEGA*(1-n);  % STEADY STATE IMPORT SHARE IN F EQUAL TO RELATIVE SIZE OF THE OTHER COUNTRY
 omegaH = n*0.15; 
 omegaF = (1-n)*0.15; 
 delta = 0.36;           % STEADY STATE SHARE OF NON-TRADEABLES IN AGGREGATE CONSUMPTION IN H
 deltastar = delta;       % STEADY STATE SHARE OF NON-TRADEABLES IN AGGREGATE CONSUMPTION IN F

 GY_T = 0;                  % STEADY STATE GOVERNMENT SPENDING
 GY_N = 0; 
 GY_Tstar = 0; 
 GY_Nstar = 0; 

% TO BE ESTIMATED 
 epsilon = 10;          % ELASTICITY OF SUBS. BETWEEN DIFFERENTIATED GOODS
 varphi = 1.5;            % ELASTICITY OF SUBS. BETWEEN H AND F GOODS
 iota = 0.74;            % ELASTICITY OF SUBS. BETWEEN N AND T GOODS

 thetaH = 2/3;          % CALVO PRICES IN H IN T-SECTOR
 thetaN = 2/3;          % CALVO PRICES IN H IN N-SECTOR
 thetaF = 2/3;          % CALVO PRICES IN F IN T-SECTOR
 thetaNstar = 2/3;      % CALVO PRICES IN F IN N-SECTOR

 mu_H = 0.6;             % SHARE OF INDEXING FIRMS IN T-SECTOR IN HOME
 mu_F = 0.6;             % SHARE OF INDEXING FIRMS IN T-SECTOR IN FOREIGN
 mu_N = 0.6;             % SHARE OF INDEXING FIRMS IN N-SECTOR IN HOME
 mu_Nstar = 0.6;         % SHARE OF INDEXING FIRMS IN N-SECTOR IN FOREIGN

 phi = 1.5;                 % MONETARY POLICY PARAMETER
 rho_R = 0.7;               % PERSISTENCE OF OF INTEREST RATE RULE

 rho_ZN = 0.7;              % SHOCK PERSISTENCE
 rho_ZNstar = 0.7;          % SHOCK PERSISTENCE
 rho_ZT = 0.7;              % SHOCK PERSISTENCE
 rho_ZTstar = 0.7;          % SHOCK PERSISTENCE
 rho_X = 0.7;               % SHOCK PERSISTENCE
 rho_G_T = 0.7;               % PERSISTENCE OF GOVERNMENT SPENDING
 rho_G_N = 0.7;               % PERSISTENCE OF GOVERNMENT SPENDING

 alpha = 0.5;               % alpha \in(0,1), WEIGHT ON L_T IN CES
 alpha_star = alpha; 
 gamma = 2;                 % ELASTICITY OF SUBSTITUTION, alpha=1 perfect substitutes, alpha=0 Cobb-Douglas, alpha=-infity perfect complements
 gamma_star = gamma; 


model; 
%%%%%%%% INTERTEMP. EULER EQUATION, HOUSEHOLD BC, DEBT MARKET, CONSUMTION AGGREGATES %%%%%%%%%%
 U_C = 1/(C-habit*C(-1)) - habit*beta*(1/(C(+1)-habit*C)); 
 U_Cstar = 1/(C_star-habit*C_star(-1)) -habit*beta*(1/(C_star(+1)-habit*C_star)); 
 U_C = beta*((R-RP*b)/Pie(+1))*U_C(+1); 
 U_Cstar = beta*((R-RP*b_star)/Pie_star(+1))*U_Cstar(+1); 

 b + C = ((R - RP*b)/Pie)*b(-1)+ Y_T*(p_over_p_T^(-1)) + Y_N*(p_over_p_N^(-1)) - LUMP;
 (1-n)*b = -n*b_star; 

 C_T = (1-delta)*C*(p_over_p_T^iota); 
 C_Tstar = (1-deltastar)*C_star*p_star_over_p_Tstar^iota;
 C_N = delta*C*(p_over_p_N^iota) ; 
 C_Nstar = deltastar*C_star*p_star_over_p_Nstar^iota ; 

%%%%%%%% CPI INFLATION, TERMS OF TRADE, LAW OF MOTION OF PRICE DISPERSION AND INFLATION %%%%%%%%%%
 Pie = Pie_T*(p_over_p_T/p_over_p_T(-1)) ; 
 Pie_star = Pie_Tstar*(p_star_over_p_Tstar/p_star_over_p_Tstar(-1)) ; 
 Pie_T = Pie_H*(p_T_over_p_H/p_T_over_p_H(-1)); 
 Pie_Tstar = Pie_F*(p_Tstar_over_p_F/p_Tstar_over_p_F(-1)); 

 ToT/ToT(-1) = Pie_F/Pie_H; 
 ToT_N/ToT_N(-1) = Pie_N/Pie_T; 
 ToT_Nstar/ToT_Nstar(-1) = Pie_Nstar/Pie_Tstar;

 dp_H = (1-thetaH)*pop_H^(-epsilon) + (thetaH*Pie_H^(epsilon))*(Pie_H(-1)^(mu_H*(-epsilon)))*dp_H(-1); 
 dp_F = (1-thetaF)*pop_F^(-epsilon) + (thetaF*Pie_F^(epsilon))*(Pie_F(-1)^(mu_F*(-epsilon)))*dp_F(-1);
 dp_N = (1-thetaN)*pop_N^(-epsilon) + (thetaN*Pie_N^(epsilon))*(Pie_N(-1)^(mu_N*(-epsilon)))*dp_N(-1);
 dp_Nstar = (1-thetaNstar)*pop_Nstar^(-epsilon) + (thetaNstar*Pie_Nstar^(epsilon))*(Pie_Nstar(-1)^(mu_Nstar*(-epsilon)))*dp_Nstar(-1);

 1 = thetaH*(Pie_H(-1)^(mu_H*(1-epsilon)))*Pie_H^(epsilon-1) + (1-thetaH)*pop_H^(1-epsilon); 
 1 = thetaF*(Pie_F(-1)^(mu_F*(1-epsilon)))*Pie_F^(epsilon-1) + (1-thetaF)*pop_F^(1-epsilon); 
 1 = thetaN*(Pie_N(-1)^(mu_N*(1-epsilon)))*Pie_N^(epsilon-1) + (1-thetaN)*pop_N^(1-epsilon); 
 1 = thetaNstar*(Pie_Nstar(-1)^(mu_Nstar*(1-epsilon)))*Pie_Nstar^(epsilon-1) + (1-thetaNstar)*pop_Nstar^(1-epsilon);

%%%%%%%% AGGREGATE LABOUR/OUTPUT, LABOUR SUPPLY (REDUNDANT UNDER STICKY WAGES) %%%%%%%%%%
 L_N = dp_N*(Y_N/(exp(X*Z_N))); 
 L_T = dp_H*(Y_T/(exp(X*Z_T)));
 L_Nstar = dp_Nstar*(Y_Nstar/(exp(X*Z_Nstar))); 
 L_Tstar = dp_F*(Y_Tstar/(exp(X*Z_Tstar)));
 L = L_N + L_T; 
 L_star = L_Nstar + L_Tstar; 

%%%%%%%% WAGES  %%%%%%%%%%
 gamma*log(V) = (1+kappa-gamma)*log(alpha*L_T^gamma + (1-alpha)*L_N^gamma);  
 gamma_star*log(V_star) = (1+kappa-gamma)*log(alpha_star*L_Tstar^gamma_star + (1-alpha_star)*L_Nstar^gamma_star);  

 U_C*w_T = alpha*(L_T^(gamma-1))*V;
 U_C*w_N = (1-alpha)*(L_N^(gamma-1))*V; 

 U_Cstar*w_Tstar = alpha_star*(L_Tstar^(gamma_star-1))*V_star; 
 U_Cstar*w_Nstar = (1-alpha_star)*(L_Nstar^(gamma_star-1))*V_star; 

 w_T/w_T(-1) = Pie_TW/Pie ; 
 w_N/w_N(-1) = Pie_NW/Pie ; 
 w_Tstar/w_Tstar(-1) = Pie_TWstar/Pie_star ;
 w_Nstar/w_Nstar(-1) = Pie_NWstar/Pie_star ; 

%%%%%%%% MARGINAL COSTS AND MARKET CLEARING %%%%%%%%%%
 mc_T = w_T*(exp(Z_T)^(-(1)))*(p_T_over_p_H)*p_over_p_T; 
 mc_N = w_N*(exp(Z_N)^(-(1)))*p_over_p_N ;
 mc_Tstar = w_Tstar*(exp(Z_Tstar)^(-(1)))*p_Tstar_over_p_F*p_star_over_p_Tstar; 
 mc_Nstar = w_Nstar*(exp(Z_Nstar)^(-(1)))*p_star_over_p_Nstar ; 

 Y_N = C_N + G_N; 
 Y_Nstar = C_Nstar + G_Nstar ;
 Y_T = ((1-omegaH)*C_T + (n/(1-n))*omegaF*C_Tstar)*(p_T_over_p_H^(varphi)) + G_T; 
 Y_Tstar = ((1-omegaF)*C_Tstar + ((1-n)/n)*omegaH*C_T)*(p_Tstar_over_p_F^(varphi)) + G_Tstar; 

%%%%%%%% MONETARY POLICY RULES, GOVERNMENT BUDGET CONSTRAINTS, GOVERNMENT SPENDING %%%%%%%%%%
 Pie_U = (1-n)*Pie + n*Pie_star; 
 R = ((1/beta)^(1-rho_R))*(R(-1)^(rho_R))*((Pie_U)^((1-rho_R)*phi))+e_M;

 G_N/Y = (1-rho_G_N)*GY_N + rho_G_N*(G_N(-1)/Y(-1)) + e_GN; 
 G_Nstar/Y_star = (1-rho_G_N)*GY_Nstar + rho_G_N*(G_Nstar(-1)/Y_star(-1)) + e_GNstar; 

 G_T/Y = (1-rho_G_T)*GY_T + rho_G_T*(G_T(-1)/Y(-1)) + e_GT; 
 G_Tstar/Y_star = (1-rho_G_T)*GY_Tstar + rho_G_T*(G_Tstar(-1)/Y_star(-1)) + e_GTstar;

 LUMP = p_over_p_N^(-1)*G_N + p_over_p_T^(-1)*G_T; 
 LUMP_star = p_star_over_p_Nstar^(-1)*G_Nstar + p_star_over_p_Tstar^(-1)*G_T;

%%%%%%%% TECHNOLOGY PROCESSES %%%%%%%%%%
 Z_T = rho_ZT*Z_T(-1)+e_Z_T + e_T; 
 Z_N = rho_ZN*Z_N(-1)+e_Z_N;
 Z_Tstar = rho_ZTstar*Z_Tstar(-1)+e_Z_Tstar + e_T;
 Z_Nstar = rho_ZNstar*Z_Nstar(-1)+e_Z_Nstar;
 X = rho_X*X(-1)+e_X; 

%%%%%%%% STICKY PRICES IN H %%%%%%%%%%
 x1_T = (epsilon/(epsilon-1))*x2_T ; 
 x1_T = Y_T*(pop_H)^(-epsilon) + thetaH*(Pie_H^(mu_H*(1-epsilon)))*Q_H*((Pie_H(+1)*(pop_H(+1)/pop_H))^(epsilon))*x1_T(+1); 
 x2_T = Y_T*(pop_H^(-(epsilon+1)))*mc_T + ((Pie_H(+1)*(pop_H(+1)/pop_H))^((epsilon+1)))*thetaH*(Pie_H^(mu_H*(-epsilon)))*Q_H*x2_T(+1);
 x1_N = (epsilon/(epsilon-1))*x2_N ; 
 x1_N = Y_N*(pop_N)^(-epsilon) + thetaN*(Pie_N^(mu_N*(1-epsilon)))*Q_H*((Pie_N(+1)*(pop_N(+1)/pop_N))^(epsilon))*x1_N(+1); 
 x2_N = Y_N*(pop_N^(-(epsilon+1)))*mc_N + ((Pie_N(+1)*(pop_N(+1)/pop_N))^((epsilon+1)))*thetaN*(Pie_N^(mu_N*(-epsilon)))*Q_H*x2_N(+1);

%%%%%%%% STICKY PRICES IN F %%%%%%%%%%
 x1_Tstar = (epsilon/(epsilon-1))*x2_Tstar ; 
 x1_Tstar = Y_Tstar*(pop_F)^(-epsilon) + thetaF*(Pie_F^(mu_F*(1-epsilon)))*Q_F*((Pie_F(+1)*(pop_F(+1)/pop_F))^(epsilon))*x1_Tstar(+1); 
 x2_Tstar = Y_Tstar*(pop_F^(-(epsilon+1)))*mc_Tstar + ((Pie_F(+1)*(pop_F(+1)/pop_F))^((epsilon+1)))*thetaF*(Pie_F^(mu_F*(-epsilon)))*Q_F*x2_Tstar(+1);
 x1_Nstar = (epsilon/(epsilon-1))*x2_Nstar ; 
 x1_Nstar = Y_Nstar*(pop_Nstar)^(-epsilon) + thetaNstar*(Pie_Nstar^(mu_Nstar*(1-epsilon)))*Q_F*((Pie_Nstar(+1)*(pop_Nstar(+1)/pop_Nstar))^(epsilon))*x1_Nstar(+1); 
 x2_Nstar = Y_Nstar*(pop_Nstar^(-(epsilon+1)))*mc_Nstar + ((Pie_Nstar(+1)*(pop_Nstar(+1)/pop_Nstar))^((epsilon+1)))*thetaNstar*(Pie_Nstar^(mu_Nstar*(-epsilon)))*Q_F*x2_Nstar(+1);

%%%%%%%% AUXILIARY VARIABLES %%%%%%%%%%
 Q_H = beta*(U_C(+1)/U_C)*(1/Pie(+1));
 Q_F = beta*(U_Cstar(+1)/U_Cstar)*(1/Pie_star(+1));

 p_T_over_p_H = ((1-omegaH) + omegaH*ToT^(1-varphi))^(1/(1-varphi));
 p_over_p_T = ((1-delta) + delta*ToT_N^(1-iota))^(1/(1-iota));
 p_over_p_N = ((1-delta)*ToT_N^(iota-1) + delta)^(1/(1-iota)); 

 p_Tstar_over_p_F = ((1-omegaF) + omegaF*(ToT^(varphi-1)))^(1/(1-varphi)); 
 p_star_over_p_Tstar = (1-deltastar + deltastar*ToT_Nstar^(1-iota))^(1/(1-iota)); 
 p_star_over_p_Nstar = ((1-deltastar)*ToT_Nstar^(iota-1) + deltastar)^(1/(1-iota)); 

 Y = (p_over_p_T)^(-1)*Y_T + (p_over_p_N)^(-1)*Y_N; 
 Y_star = (p_star_over_p_Tstar)^(-1)*Y_Tstar + (p_star_over_p_Nstar)^(-1)*Y_Nstar; 

 NONTRADEDINFLATION = (ln(Pie_N))*100;

 REL = Y_T/Y_Tstar; 


%%%%%%%% OBSERVATION EQUATIONS %%%%%%%%%%
 Pie_obs = Pie; 
 Pie_N_obs = Pie_N; 
 Pie_star_obs = Pie_star; 
 Pie_Nstar_obs = Pie_Nstar; 
 L_T_obs = (L_T-steady_state(L_T))/steady_state(L_T) + ME_L_T; 
 L_obs = (L-steady_state(L))/steady_state(L) + ME_L; 
 Y_obs = (Y-steady_state(Y))/steady_state(Y) + ME_Y; 
 Y_N_obs = (Y_N-steady_state(Y_N))/steady_state(Y_N) + ME_Y_N; 
 Y_star_obs = (Y_star-steady_state(Y_star))/steady_state(Y_star) + ME_Ystar; 
 Y_Nstar_obs = (Y_Nstar-steady_state(Y_Nstar))/steady_state(Y_Nstar) + ME_Y_Nstar; 
 R_obs = R; 

%%% NEED WAGE DATA! %%%%
end; 

shocks;
 var e_Z_T=0.01;
 var e_Z_N=0.01;
 var e_Z_Tstar=0.01;
 var e_Z_Nstar=0.01;
 var e_GT=0.01;
 var e_GN=0.01;
 var e_GTstar=0.01;
 var e_GNstar=0.01;
 var e_M=0.01;
 %var e_X=0.01;
 var e_T=0.01;
 % var ME_L=0.01;
 % var ME_L_T=0.01;
 % var ME_Y=0.01;
 % var ME_Y_T=0.01;
 % var ME_Ystar=0.01;
 %var ME_Y_Tstar=0.01;
end;


steady_state_model;   
    b = 0; 
    b_star = 0;
    Z_T = 0; 
    Z_Tstar = 0; 
    Z_N = 0; 
    Z_Nstar = 0;  
    X = 0; 
    Pie_U = 1;   
    Pie = 1; 
    Pie_N = 1; 
    Pie_T = 1; 
    Pie_H = 1; 
    Pie_NW = 1; 
    Pie_TW = 1; 
    Pie_star = 1; 
    Pie_Nstar = 1;
    Pie_Tstar = 1;
    Pie_F = 1;
    Pie_NWstar = 1;
    Pie_TWstar = 1;
    pop_H = 1; 
    pop_N = 1;     
    pop_F = 1;
    pop_Nstar = 1; 
    dp_H = 1; 
    dp_N = 1;   
    dp_F = 1;
    dp_Nstar = 1;
    R = 1/beta;   
    Q_H = beta; 
    Q_F = beta;   
    mc_T = (epsilon-1)/epsilon ; 
    mc_N = (epsilon-1)/epsilon ; 
    mc_Tstar = (epsilon-1)/epsilon ; 
    mc_Nstar = (epsilon-1)/epsilon ;
    %%%% NEED THESE!!! %%%%
    %ToT = ToT_steady_state(omegaH, omegaF, varphi,n); % XXX
    ToT = 1; 
    p_T_over_p_H = ((1-omegaH) + omegaH*ToT^(1-varphi))^(1/(1-varphi));
    p_Tstar_over_p_F = ((1-omegaF) + omegaF*(ToT^(varphi-1)))^(1/(1-varphi));     
    ToT_N = ToT_N_steady_state(delta, iota,alpha, gamma); 
    ToT_Nstar=ToT_N; 
    %ToT_Nstar = ToT_Nstar_steady_state(deltastar, iota, omegaH, omegaF, alpha_star, gamma_star, n, p_Tstar_over_p_F, varphi);  % XXX
    %%%% NEED THESE!!! %%%%
    p_over_p_T = ((1-delta) + delta*ToT_N^(1-iota))^(1/(1-iota));
    p_over_p_N = ((1-delta)*ToT_N^(iota-1) + delta)^(1/(1-iota)); 
    p_star_over_p_Tstar = (1-deltastar + deltastar*ToT_Nstar^(1-iota))^(1/(1-iota)); 
    p_star_over_p_Nstar = ((1-deltastar)*ToT_Nstar^(iota-1) + deltastar)^(1/(1-iota)); 
    w_T = mc_T/((p_T_over_p_H)*p_over_p_T); 
    w_N = mc_N/p_over_p_N; 
    w_Tstar = mc_Tstar/(p_Tstar_over_p_F*p_star_over_p_Tstar); 
    w_Nstar = mc_Nstar/p_star_over_p_Nstar; 
    C = C_steady_state(alpha, delta, p_over_p_N, iota, kappa, gamma, habit, beta, mc_N, p_over_p_T); % XXX
    U_C = ((1-habit*beta)/(1-habit))*(1/C);        
    G_T = 0; 
    G_N = 0; 
    Y = C;
    C_N = delta*C*(p_over_p_N^iota);
    C_T = (1-delta)*C*(p_over_p_T^iota); 
    Y_N = C_N;   
    C_star = C_star_steady_state(alpha_star, deltastar, p_star_over_p_Nstar, iota, kappa, gamma_star, habit, beta, mc_Nstar, p_star_over_p_Tstar) ; 
    U_Cstar = ((1-habit*beta)/(1-habit))*(1/C_star);     
    G_Tstar = 0; 
    G_Nstar = 0; 
    Y_star = C_star;
    C_Nstar = deltastar*C_star*(p_star_over_p_Nstar^iota);
    C_Tstar = (1-deltastar)*C_star*(p_star_over_p_Tstar^iota); 
    Y_Nstar = C_Nstar ; 
    Y_T = ((1-omegaH)*C_T + (n/(1-n))*omegaF*C_Tstar)*(p_T_over_p_H^(varphi)); 
    L_T = Y_T; 
    L_N = Y_N; 
    Y_Tstar = ((1-omegaF)*C_Tstar + ((1-n)/n)*omegaH*C_T)*(p_Tstar_over_p_F^(varphi)) ; 
    L_Tstar = Y_Tstar; 
    L_Nstar = Y_Nstar; 
    L = L_T + L_N ; 
    L_star = L_Tstar + L_Nstar; 
    REL = Y/Y_star; 
    x1_T = (1/(1-thetaH*Q_H))*Y_T; 
    x1_Tstar = (1/(1-thetaF*Q_F))*Y_Tstar; 
    x1_N = (1/(1-thetaN*Q_H))*Y_N; 
    x1_Nstar = (1/(1-thetaNstar*Q_F))*Y_Nstar; 
    x2_T = ((epsilon-1)/epsilon)*x1_T; 
    x2_Tstar = ((epsilon-1)/epsilon)*x1_Tstar; 
    x2_N = ((epsilon-1)/epsilon)*x1_N; 
    x2_Nstar = ((epsilon-1)/epsilon)*x1_Nstar;  
    V = (alpha*L_T^gamma + (1-alpha)*L_N^gamma)^((1+kappa-gamma)/gamma); 
    V_star = (alpha_star*L_Tstar^gamma_star + (1-alpha_star)*L_Nstar^gamma_star)^((1+kappa-gamma_star )/gamma_star); 
    NONTRADEDINFLATION = 0; 
    LUMP = 0; 
    LUMP_star = 0; 
    Pie_obs = 1; 
    Pie_N_obs = 1; 
    Pie_star_obs = 1; 
    Pie_Nstar_obs = 1; 
    L_T_obs = 0; 
    L_obs = 0; 
    Y_obs = 0; 
    Y_N_obs = 0; 
    Y_star_obs = 0; 
    Y_Nstar_obs = 0; 
    R_obs = 1/beta; 
end; 


steady; 
check; %check the eigenvalues of the system
%stoch_simul(periods=250,irf=30,order=1) Pie_N; 

estimated_params;
thetaH, 0.75 ,0,0.99, beta_pdf, 0.75, 0.15;
thetaN, 0.75 ,0,0.99, beta_pdf, 0.75, 0.15;
thetaF, 0.75 ,0,0.99, beta_pdf, 0.75, 0.15;
thetaNstar, 0.75 ,0,0.99, beta_pdf, 0.75, 0.15;

mu_H, 0.6 ,0,0.99, beta_pdf, 0.6, 0.2;
mu_F, 0.6 ,0,0.99, beta_pdf, 0.6, 0.2;
mu_N, 0.6 ,0,0.99, beta_pdf, 0.6, 0.2;
mu_Nstar, 0.6 ,0,0.99, beta_pdf, 0.6, 0.2;

phi, normal_pdf, 1.5, 0.1; 
rho_R, beta_pdf, 0.7, 0.1; 
rho_ZT, beta_pdf, 0.7, 0.1; 
rho_ZN, beta_pdf, 0.7, 0.1; 
rho_ZTstar, beta_pdf, 0.7, 0.1; 
rho_ZNstar, beta_pdf, 0.7, 0.1; 
% rho_X ,beta_pdf, 0.7, 0.1; 
rho_G_T, beta_pdf, 0.7, 0.1; 
rho_G_N, beta_pdf, 0.7, 0.1; 

stderr e_Z_T, gamma_pdf, 0.7, 0.3; 
stderr e_Z_N, gamma_pdf, 0.7, 0.3; 
stderr e_Z_Tstar, gamma_pdf, 0.7, 0.3; 
stderr e_Z_Nstar, gamma_pdf, 0.7, 0.3; 
% stderr e_X, gamma_pdf, 0.7, 0.3; 
stderr e_M, gamma_pdf, 0.4, 0.2; 
stderr e_T, gamma_pdf, 0.7, 0.3; 

stderr e_GT, gamma_pdf, 1, 0.5; 
stderr e_GN, gamma_pdf, 1, 0.5; 
stderr e_GTstar, gamma_pdf, 1, 0.5; 
stderr e_GNstar, gamma_pdf, 1, 0.5; 

% stderr ME_L, gamma_pdf, 0.2, 0.1; 
% stderr ME_Y, gamma_pdf, 0.2, 0.1; 
% stderr ME_L_T, gamma_pdf, 0.2, 0.1; 
% stderr ME_Y_N, gamma_pdf, 0.2, 0.1; 
% stderr ME_Y_Nstar, gamma_pdf, 0.2, 0.1; 
% stderr ME_Ystar, gamma_pdf, 0.2, 0.1; 

% varphi, gamma_pdf, 1, 0.5; 
% iota, gamma_pdf, 0.5, 0.2; 
alpha, 0.5, 0.1, 0.9, normal_pdf, 0.5, 0.1; 
gamma,uniform_pdf,,,1,3; 
end;

varobs Pie_obs Pie_N_obs Pie_star_obs Pie_Nstar_obs Y_obs Y_N_obs Y_star_obs Y_Nstar_obs; 


estimation(mode_compute=0, mode_file=nestedCES_mode , lik_init=1,order=1,plot_priors=0,datafile=dataforestimation ,mh_replic=500000,mh_nblocks=4,mh_drop=0.2,mh_jscale=0.1,mode_check, bayesian_irf) Pie_N Pie_Nstar; 
identification; 

prior_function(sampling_draws=10000, function=prior_func);
prior_irfs_Pie_N_e_Z_T=cell2mat(oo_.prior_function_results(:,1));
prior_irfs_Pie_e_Z_T=cell2mat(oo_.prior_function_results(:,2));
prior_irfs_Pie_N_e_T=cell2mat(oo_.prior_function_results(:,3));
prior_irfs_Pie_e_T=cell2mat(oo_.prior_function_results(:,4));
% prior_irfs_Pie_N_e_X=cell2mat(oo_.prior_function_results(:,5));
% prior_irfs_Pie_e_X=cell2mat(oo_.prior_function_results(:,6));

% get mean IRF and quantiles. Example here for Pie_N_e_Z_T
mean_irf_Pie_N_e_Z_T = mean(prior_irfs_Pie_N_e_Z_T)

upper_irf_Pie_N_e_Z_T = quantile(prior_irfs_Pie_N_e_Z_T,1);
lower_irf_Pie_N_e_Z_T = quantile(prior_irfs_Pie_N_e_Z_T,0);

% Plot 'credible set' for the IRFs given priors including the mean response
time = 1:20; 
prior_check_plot = plot(time, upper_irf_Pie_N_e_Z_T,'k');
hold on;
plot(time, lower_irf_Pie_N_e_Z_T, 'k');
x = [time, fliplr(time)];
inBetween = [upper_irf_Pie_N_e_Z_T, fliplr(lower_irf_Pie_N_e_Z_T)];
fill(x, inBetween,[0.75 0.75 0.75]);
plot(time, mean_irf_Pie_N_e_Z_T, 'k', 'LineWidth', 3);

internals --display-mh-history nestedCES

%stoch_simul(periods=200,irf=30,order=1, noprint, nograph, nodisplay) ; 
%     pause
% %%%%%%%%%%% SURF PLOTS FOR MOTIVATION %%%%%%%%%%%
% thetas = 0:0.1:0.9;
% mu_Hs = 0:0.1:0.9;

%  for s = 1:length(thetas); 
%     habit = 0; 
%     thetaH = thetas(s);
%     thetaF = thetas(s);
%     thetaN = thetas(s);
%     thetaNstar = thetas(s);
%  for k = 1:length(mu_Hs); 
%     mu_H = mu_Hs(k);  
%     mu_F = mu_H; 
%     mu_N = mu_H;
%     mu_Nstar = mu_H; 
%     stoch_simul(order = 1,irf=20, nodisplay, nograph, noprint) NONTRADEDINFLATION;
%     Pie_N_theta_mu(:,k) = NONTRADEDINFLATION_e_Z_T(1);
%  end  
%  b_one_Pie_N_theta_mus(: , s) = Pie_N_theta_mu; 
%  end

%   for s = 1:length(thetas); 
%     habit = 0.3; 
%     thetaH = thetas(s);
%     thetaF = thetas(s);
%     thetaN = thetas(s);
%     thetaNstar = thetas(s);
%  for k = 1:length(mu_Hs); 
%     mu_H = mu_Hs(k);  
%     mu_F = mu_H; 
%     mu_N = mu_H;
%     mu_Nstar = mu_H; 
%     stoch_simul(order = 1,irf=20, nodisplay, nograph, noprint) NONTRADEDINFLATION;
%     Pie_N_theta_mu(:,k) = NONTRADEDINFLATION_e_Z_T(1);
%  end  
%  b_two_Pie_N_theta_mus(: , s) = Pie_N_theta_mu; 
%  end

%    for s = 1:length(thetas); 
%     habit = 0.6; 
%     thetaH = thetas(s);
%     thetaF = thetas(s);
%     thetaN = thetas(s);
%     thetaNstar = thetas(s);
%  for k = 1:length(mu_Hs); 
%     mu_H = mu_Hs(k);  
%     mu_F = mu_H; 
%     mu_N = mu_H;
%     mu_Nstar = mu_H; 
%     stoch_simul(order = 1,irf=20, nodisplay, nograph, noprint) NONTRADEDINFLATION;
%     Pie_N_theta_mu(:,k) = NONTRADEDINFLATION_e_Z_T(1);
%  end  
%  b_three_Pie_N_theta_mus(: , s) = Pie_N_theta_mu; 
%  end

% redChannel = b_one_Pie_N_theta_mus > 0;
% greenChannel = b_one_Pie_N_theta_mus < 0;
% blueChannel = greenChannel;
% % Make the RGB image.
% colors_one = double(cat(3, redChannel, greenChannel, blueChannel));

% redChannel = b_two_Pie_N_theta_mus > 0;
% greenChannel = b_two_Pie_N_theta_mus < 0;
% blueChannel = greenChannel;
% % Make the RGB image.
% colors_two = double(cat(3, redChannel, greenChannel, blueChannel));

% redChannel = b_three_Pie_N_theta_mus > 0;
% greenChannel = b_three_Pie_N_theta_mus < 0;
% blueChannel = greenChannel;
% % Make the RGB image.
% colors_three = double(cat(3, redChannel, greenChannel, blueChannel));

% subplot(1,3,1)
% surf(thetas, mu_Hs, b_one_Pie_N_theta_mus,colors_one)
% colormap(jet)
% ylabel('$\mu$','interpreter','latex', 'FontSize', 18)
% xlabel('$\theta$','interpreter','latex', 'FontSize', 18)
% title('$b=0$','interpreter','latex', 'FontSize', 18)

% subplot(1,3,2)
% surf(thetas, mu_Hs, b_two_Pie_N_theta_mus,colors_two)
% ylabel('$\mu$','interpreter','latex', 'FontSize', 18)
% xlabel('$\theta$','interpreter','latex', 'FontSize', 18)
% title('$b=0.3$','interpreter','latex', 'FontSize', 18)

% subplot(1,3,3)
% surf(thetas, mu_Hs, b_three_Pie_N_theta_mus ,colors_three)
% ylabel('$\mu$','interpreter','latex', 'FontSize', 18)
% xlabel('$\theta$','interpreter','latex', 'FontSize', 18)
% title('$b=0.6$','interpreter','latex', 'FontSize', 18)

